﻿------Globals
ChannelName = "ShareTheRare"
ChanID = nil
local Channels = {}
local UnitData = {}
local Timeout = nil
local Tracked = {}
local Timer = 1
local Prefix = "STR"
local HashCheck 


local function GetHash(text)
  local counter = 0; 
  local len = string.len(text); 
  for i = 1, len do 
    counter = (counter*31) + string.byte(text, i)
    counter = mod(counter, 4294967296);	-- 2^32
  end; 
  return mod(counter, 4294967296);  -- 2^32
end 


local function IsInChannel()
	local Bool = false
	Channels = {GetChannelList()}
	for i = 1,#Channels do
		if Channels[i] == ChannelName then 
			ChanID = Channels[i-1]
			Bool = true
		end
	end
	return Bool
end 

local function JoinChannel()
	
	if Timeout ~=nil then
		if GetTime()>Timeout then 
			JoinTemporaryChannel(ChannelName, "Onlyforus");
			RegisterAddonMessagePrefix(Prefix)
		end 
	else 
		Timeout = GetTime() +10
	end
end

local function FireOncePer(seconds)
	if Timer>GetTime() then --Not yet
		return false
	elseif Timer<GetTime() then --Now
		Timer = (GetTime()+seconds)
		return true
	end
end

function split(s, delimiter)
    result = {};
    for match in (s..delimiter):gmatch("(.-)"..delimiter) do
        table.insert(result, match);
    end
    return result;
end


local function OnEvent(self, event, prefix, message, channel, sender)
	if prefix == Prefix then
		local var = {}
		var = split(message,"-")
		local HashRec = var[1]
		local msg = var[2]
		local HashGen = GetHash(msg)
		if HashRec then 
			print("|cFFD4AF37[STR] |CFFB22BAD"..sender..msg)
		end
	end 
end 


local function STR_OnEvent(self,event,...)
	if event=="PLAYER_ENTERING_WORLD" then
	
	elseif event=="WORLD_MAP_UPDATE" then 
		if IsInChannel() == false then
			JoinChannel();
		end
	
	elseif event == "NAME_PLATE_UNIT_ADDED" or event == "FORBIDDEN_NAME_PLATE_UNIT_ADDED" then
		local namePlateUnitToken = ...;
		
		if FireOncePer(1) then 
			local Name = UnitName(namePlateUnitToken)
			local Area = GetSubZoneText()
			local Playername = UnitName("player")
			local Guid = UnitGUID(namePlateUnitToken)
			local NPCtype, zero, ServerId, InstanceId, ZoneUID, NPCID, SpawnUID = strsplit("-",Guid)
			--SendChatMessage(Playername.." has found: "..Name.." In: "..Area,"CHANNEL" ,nil,ChanID)
			local Allow = true 
			for ind = 1,#Tracked do 
				if Tracked[ind] == Guid then 
					Allow = false 
				end
			end 
		
			for i = 1,#RaresNameList do
				if Name == RaresNameList[i] and IsInChannel() == true and Allow == true then
					local msg = "|cFFE3DEDB has found: |cFF00FFFF["..Name.."]|cFFE3DEDB   In: |cFF86f441["..Area.."]"
					local Hash = GetHash(msg)
					SendAddonMessage(Prefix, Hash.."-"..msg , "CHANNEL" ,ChanID)
					--SendChatMessage("Have found: "..Name.." -- In: "..Area,"CHANNEL" ,nil,ChanID)
					Tracked[#Tracked+1] = Guid
				end 
			end 
		end	
	end
end 


SLASH_STR1 = "/sharetherare";
SLASH_STR2 = "/str";
local function handler(msg, editbox)
	local command, str = msg:match("^(%S*)%s*(.-)$");
	if command == "print" then 
		print("|cFFD4AF37[STR]|cFFE3DEDB"..ChanID..":");
		JoinChannel()
	else
		print("|cFFD4AF37[STR]|cFFE3DEDB Command not recognized")
	end
	
end
SlashCmdList["STR"] = handler;



local frame = CreateFrame("Frame");
frame:RegisterEvent("PLAYER_ENTERING_WORLD");
frame:RegisterEvent("CHAT_MSG_CHANNEL");
frame:RegisterEvent("CHAT_MSG_CHANNEL_NOTICE_USER");
frame:RegisterEvent("CHAT_MSG_CHANNEL_LEAVE");
frame:RegisterEvent("CHAT_MSG_CHANNEL_NOTICE");
frame:RegisterEvent("GROUP_ROSTER_UPDATE")
frame:RegisterEvent("WORLD_MAP_UPDATE")
frame:RegisterEvent("NAME_PLATE_UNIT_ADDED")
frame:RegisterEvent("FORBIDDEN_NAME_PLATE_UNIT_ADDED");

frame:SetScript("OnEvent", STR_OnEvent)

local frame2 = CreateFrame("Frame");
frame2:RegisterEvent("CHAT_MSG_ADDON");

frame2:SetScript("OnEvent", OnEvent)